/* cliserv.c - Prueba con 2 sockets */

/*---------------------------------------------------------------------
Modulo: cliserv.c
Fecha: 27 Febrero 1996
Autor: Fernando J. Echevarrieta Fernandez
Version: 1.0
Comentarios:
   s_topserver : Actua como llamante
   botclient   : Actua como llamado

---------------------------------------------------------------------*/

#include <unistd.h>     /* fork */
#include <stdlib.h>     /* malloc */
#include <sys/types.h>
#include <sys/socket.h> /* socket, bind, listen */
#include <netinet/in.h> /* struct sockaddr_in */
#include <string.h>	/* strcmp, strcp, strcpy, memcpy */
#include <sys/time.h>	/* Macros FD */

#define MAXLENMSG  256
#define TOPSERVER_PORT 2000 
#define BOTCLIENT_PORT 2001

char message[MAXLENMSG];
int s_topserver, botclient, ns, statuslen;
struct sockaddr_in topserver;

fd_set sock_set, active_sock_set;

main()
{
	int i, num_sock_set;

	char message[MAXLENMSG];

	/* Goes to background */ 
	if ( fork() != 0 ) {
	   printf("2_sock: OK\n");
	   exit(0);
	}

	/* Starts communication processes */
	botclient   = launch(); 
	s_topserver = topserver_connect();

	num_sock_set = getdtablesize();
	FD_ZERO(&active_sock_set);

	FD_SET(botclient,    &active_sock_set);
	FD_SET(s_topserver, &active_sock_set);

	while (1) {
	    bcopy((char *)&active_sock_set,(char *)&sock_set,sizeof(sock_set));

	    select(num_sock_set,&sock_set,(fd_set *)0,(fd_set *)0,
                   (struct timeval *)0); 

	    if (FD_ISSET(botclient,    &sock_set)) {
		botclient_process();
	    }

	    if (FD_ISSET(s_topserver, &sock_set)) {
		topserver_process();
	    }
	}

}

/* ---------------------------------------------------------------- */

launch()
/* Launches server for botclient program */
{
	int s;

	topserver.sin_family=AF_INET;
	topserver.sin_port  =htons(BOTCLIENT_PORT);
	topserver.sin_addr.s_addr=inet_addr("127.0.0.1");

        /* Creates socket*/
        s=socket(AF_INET, SOCK_STREAM, 0);
        if (s<0) 
        {
                perror("server:socket");
                exit(1);
        }

        /* Binds it to the port */
        if (bind(s,(struct sockaddr *)&topserver,sizeof(topserver)) < 0) 
        {
                perror("server:bind");
                exit(1);
        }

        /* And listens */
        listen(s,3);

	/* Returns socket descriptor */
	return s;

} /* end launch */

/* ---------------------------------------------------------------- */

topserver_connect()
/* Connects topserver and returns -1 if failed */
{
        int s;
	char buf[MAXLENMSG];
        struct sockaddr_in topserver;

        topserver.sin_family     =AF_INET;
        topserver.sin_port       =htons(TOPSERVER_PORT);
        topserver.sin_addr.s_addr=inet_addr("127.0.0.1");

        s=socket(AF_INET,SOCK_STREAM,0);

        /* Connects topserver server */
        if (connect(s,(struct sockaddr *)&topserver,sizeof(topserver)) == -1) 
        {
                perror("client:connect");
                exit(1);
        }

        write(s,"MENSAJE DE CONTACTO",sizeof("MENSAJE DE CONTACTO"));

	return s;

} /* end topserver_connect */

/* ---------------------------------------------------------------- */

botclient_process()
/* Processes a botclient request */
{
	char buf[256];
	int c;

	ns=accept(botclient,INADDR_ANY,&statuslen);
        c=read(ns,buf,MAXLENMSG);
        printf("cliserv: BOTCLIENT message:'%s'\n",buf);
        write(ns,buf,c);

	close(ns);
}

/* ---------------------------------------------------------------- */

topserver_process()
/* Processes a message from topserver */
{
	char buf[256];

        if (read(s_topserver,buf,255) <= 0) {
           perror("cliserv: Error");
	   exit(1);
	}
        printf("cliserv: TOPSERVER msg:'%s'\n",buf); 
}

/* ---------------------------------------------------------------- */

read_message(int s,char *buf)
/* Returns a new socket ns and puts requests in buf */
{
	int c, ns;

        /* Accepts connections */
        statuslen=sizeof(topserver);
        ns=accept(s,INADDR_ANY,&statuslen);
        if (ns<0) 
        {
                printf("server:accept error %s\n",ns);
                exit(1);
        }

        /* Receives a message from client and re-sends it */
        c=read(ns,buf,MAXLENMSG);
        printf("topserver: Test Message received:'%s'\n",buf);
        write(ns,buf,c);

        /* Receives request */
        c=read(ns,buf,MAXLENMSG);
	buf[c]='\0';

        printf("topserver: Message received:'%s'\n",buf);

	return ns;

} /* end read_message */

/* ---------------------------------------------------------------- */
