/* topserver.c - Servidor generador de mensajes */

/*---------------------------------------------------------------------
Modulo: topserver.c
Fecha: 27 Febrero 1996
Autor: Fernando J. Echevarrieta Fernandez
Version: 1.0 
Descripcion: 
	Servidor que escucha en el puerto TOPSERVER_PORT y cuando 
recibe una conexion envia por ella un mensaje cada tres segundos
---------------------------------------------------------------------*/

#include <unistd.h>     /* fork */
#include <stdlib.h>     /* malloc */
#include <sys/types.h>
#include <sys/socket.h> /* socket, bind, listen */
#include <netinet/in.h> /* struct sockaddr_in */
#include <string.h>	/* strcmp, strcp, strcpy, memcpy */
#include <signal.h>

#define MAXLENMSG  256
#define TOPSERVER_PORT 2000 
#define MSG_SEND "HOLA"

char message[MAXLENMSG];
int s_topserver, ns, statuslen;
struct sockaddr_in topserver;

envia()
{
	signal(SIGALRM,(void *)envia);
	alarm(3);
	printf("topserver: Envio mensaje\n");
	write(ns,MSG_SEND,sizeof(MSG_SEND));
}

main()
{
	int i;
	char message[MAXLENMSG];

	/* Goes to background */ 
	if ( fork() != 0 ) {
	   printf("topserver: OK\n");
	   exit(0);
	}

	/* Starts communication processes */
	s_topserver    = launch(); 

	ns=read_message(s_topserver,message);

	while (1) {}
}

/* ---------------------------------------------------------------- */

launch()
/* Launches server */
{
	int s;

	topserver.sin_family=AF_INET;
	topserver.sin_port  =htons(TOPSERVER_PORT);
	topserver.sin_addr.s_addr=inet_addr("127.0.0.1");

        /* Creates socket*/
        s=socket(AF_INET, SOCK_STREAM, 0);
        if (s<0) 
        {
                perror("server:socket");
                exit(1);
        }

        /* Binds it to the port */
        if (bind(s,(struct sockaddr *)&topserver,sizeof(topserver)) < 0) 
        {
                perror("server:bind");
                exit(1);
        }

        /* And listens */
        listen(s,3);

	/* Returns socket descriptor */
	return s;

} /* end launch */

/* ---------------------------------------------------------------- */

read_message(int s,char *buf)
/* Returns a new socket ns and puts requests in buf */
{
	int c, ns;

        /* Accepts connections */
        statuslen=sizeof(topserver);
        ns=accept(s,INADDR_ANY,&statuslen);
        if (ns<0) 
        {
                printf("server:accept error %s\n",ns);
                exit(1);
        }

        /* Receives a message from client and re-sends it */
        c=read(ns,buf,MAXLENMSG);
        printf("topserver: Test Message received:'%s'\n",buf);
        write(ns,buf,c);

	signal(SIGALRM,(void *)envia);
	alarm(3);

	return ns;

} /* end read_message */

/* ---------------------------------------------------------------- */
